// Code generated by gen-go-code.py; DO NOT EDIT.




// License: GPLv3 Copyright: 2022, Kovid Goyal, <kovid at kovidgoyal.net>

// Code generated by gen-go-code.py; DO NOT EDIT.

package at

import (
	"fmt"
	"strings"
	"time"

	"kitty/tools/cli"
	"kitty/tools/utils"
)

var _ = fmt.Print
var _ = strings.Join

type options_ls_type struct {
	AllEnvVars bool
}

var options_ls options_ls_type

type ls_json_type struct {
	All_env_vars bool`json:"all_env_vars,omitempty"`
}

func create_payload_ls(io_data *rc_io_data, cmd *cli.Command, args []string) (err error) {
	payload := ls_json_type{}
	if len(args) != 0 { return fmt.Errorf("%s", "Unknown extra argument(s) supplied to ls") }
payload.All_env_vars = options_ls.AllEnvVars
	io_data.rc.Payload = payload
	return
}

func create_rc_ls(args []string) (*utils.RemoteControlCmd, error) {
	rc := utils.RemoteControlCmd{
		Cmd:        "ls",
		Version:    ProtocolVersion,
		NoResponse: false,
		Stream:     false,
	}
	if rc.Stream {
		stream_id, err := utils.HumanRandomId(128)
		if err != nil {
			return nil, err
		}
		rc.StreamId = stream_id
	}
	if false {
		async_id, err := utils.HumanRandomId(128)
		if err != nil {
			return nil, err
		}
		rc.Async = async_id
	}
	return &rc, nil
}

func run_ls(cmd *cli.Command, args []string) (return_code int, err error) {
	err = cmd.GetOptionValues(&options_ls)
	if err != nil {
		return
	}

	rc, err := create_rc_ls(args)
	if err != nil {
		return
	}
	nrv, err := cli.GetOptionValue[bool](cmd, "NoResponse")
	if err == nil {
		rc.NoResponse = nrv
	}
	var timeout float64 = 10.0
	rt, err := cli.GetOptionValue[float64](cmd, "ResponseTimeout")
	if err == nil {
		timeout = rt
	}
	io_data := rc_io_data{
		cmd:                    cmd,
		rc:                     rc,
		timeout:                time.Duration(timeout * float64(time.Second)),
		string_response_is_err: false,
	}
	err = create_payload_ls(&io_data, cmd, args)
	if err != nil {
		return
	}

	err = send_rc_command(&io_data)
	return
}

func setup_ls(parent *cli.Command) *cli.Command {
	ans := parent.AddSubCommand(&cli.Command{
		Name:             "ls",
		Usage:            "",
		ShortDescription: "List all tabs/windows",
		HelpText:         "List all windows. The list is returned as JSON tree. The top-level is a list of operating system kitty windows. Each OS window has an :italic:`id` and a list of :italic:`tabs`. Each tab has its own :italic:`id`, a :italic:`title` and a list of :italic:`windows`. Each window has an :italic:`id`, :italic:`title`, :italic:`current working directory`, :italic:`process id (PID)`, :italic:`command-line` and :italic:`environment` of the process running in the window. Additionally, when running the command inside a kitty window, that window can be identified by the :italic:`is_self` parameter.\n\nYou can use these criteria to select windows/tabs for the other commands.",
		Run:              run_ls,
	})
	ans.StopCompletingAtArg = 0
ans.Add(cli.OptionSpec{
            Name: "--all-env-vars",
            Type: "bool-set",
            Dest: "AllEnvVars",
            Help: "Show all environment variables in output, not just differing ones.",
        })
	return ans
}

func init() {
	register_at_cmd(setup_ls)
}
